cabal-version:      2.4
name:               ppbl2023-plutus-template
version:            1.0.0
description:        Templates for Plutus Project-Based Learning
license:            Apache-2.0
author:             Gimbalabs PPBL
maintainer:         gimbalabs.com
build-type:         Simple

Flag unexpected_thunks
  Description:   Turn on unexpected thunks checks
  Default:       False

common base
  build-depends: base >= 4.14 && < 4.15

common project-config
  default-language:     Haskell2010

  default-extensions:   NoImplicitPrelude
                        OverloadedStrings

  ghc-options:          -Wall
                        -Wcompat
                        -Wincomplete-record-updates
                        -Wpartial-fields
                        -Wredundant-constraints
                        -Wincomplete-uni-patterns
                        -Wmissing-export-lists
                        -Wpartial-fields
                        -Wmissing-deriving-strategies
                        -Wunused-packages

common maybe-Win32
  if os(windows)
     build-depends:    Win32

library
  import:               base, project-config
                      , maybe-Win32

  if flag(unexpected_thunks)
    cpp-options: -DUNEXPECTED_THUNKS

  hs-source-dirs:       src

  exposed-modules:    AlwaysSucceeds.Compiler
                    , AlwaysSucceeds.Validator
                    , AlwaysSucceeds.TypedValidator
                    , Tokens.Compiler
                    , Tokens.Minter
                    , PPBLNFT.Compiler
                    , PPBLNFT.Minter
                    , Lockbox.Compiler
                    , Lockbox.Types
                    , Lockbox.Validator
                    , FaucetMiniProject.Validator
                    , FaucetMiniProject.Types
                    , FaucetMiniProject.Compiler

  build-depends:       base ^>=4.14.3.0
                    , aeson
                    , bytestring
                    , containers
                    , cardano-api
                    , data-default
                    , plutus-ledger-api
                    , plutus-script-utils
                    , plutus-tx-plugin
                    , plutus-tx
                    , text
                    , serialise
                    , plutus-core
                    , tagged
                    , prettyprinter
                    , cardano-api
                    , directory
                    , gimbalabs-utils


  ghc-options: -fobject-code -fno-ignore-interface-pragmas -fno-omit-interface-pragmas
